unit Ex1u1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, DBCtrls, ExtCtrls, Grids, DBGrids, DB,
  DBTables, dbiProcs, dbiTypes;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Panel1: TPanel;
    DBNavigator1: TDBNavigator;
    Panel2: TPanel;
    BitBtn1: TBitBtn;
    Button1: TButton;
    Button2: TButton;
    Table1Del: TStringField;
    Label1: TLabel;
    Button3: TButton;
    Button4: TButton;
    Table1LAST_NAME: TStringField;
    Table1FIRST_NAME: TStringField;
    Table1ACCT_NBR: TFloatField;
    procedure Table1CalcFields(DataSet: TDataset);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Table1CalcFields(DataSet: TDataset);
var
  Pr : RECProps;
begin
  dbiGetRecord(Table1.Handle, dbiNoLock, NIL, @Pr);
  if Pr.bDeleteFlag then
    Table1Del.AsString:='*'
  else
    Table1Del.AsString:=' ';
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  dbiSetProp(hDBIObj(Table1.Handle), curSOFTDELETEON, 1);
  Table1.Refresh;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  dbiSetProp(hDBIObj(Table1.Handle), curSOFTDELETEON, 0);
  Table1.Refresh;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  if Table1.State=dsBrowse then Table1.Edit;
  if  DbiUndeleteRecord(Table1.Handle) = 0 then
    Table1.Refresh
  else
    MessageDlg('Record NOT deleted',mtError,[mbOK],0);
end;

procedure TForm1.DataSource1DataChange(Sender: TObject; Field: TField);
var
  Pr : RECProps;
begin
  if Table1.State=dsBrowse then begin
    Table1.UpdateCursorPos;
    dbiGetRecord(Table1.Handle, dbiNoLock, NIL, @Pr);
    LAbel1.Caption:='Record  '+IntToStr(Pr.iPhyRecNum);
  end;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
  PN, PD : PChar;
  RR : dbiResult;
begin
  Table1.Active:=False;
  Table1.Exclusive:=True;
  Table1.Active:=True;
  PN:='c:\d\demos\data\clients.dbf';
  PD:='DBASE';
  if DbiPackTable (Table1.DBHandle , Table1.Handle, NIL, NIL, False)<>0 then
    MessageDlg('Packing Error', mtError, [mbOK], 0);
  Table1.Active:=False;
  Table1.Exclusive:=False;
  Table1.Active:=True;

end;

end.
