unit Ex3u1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DB, DBTables, Grids, DBGrids, dbiProcs, dbiTypes,
  Buttons, ExtCtrls;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Panel1: TPanel;
    Button1: TButton;
    Panel2: TPanel;
    BitBtn1: TBitBtn;
    Edit1: TEdit;
    Label1: TLabel;
    Button2: TButton;
    OpenDialog1: TOpenDialog;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}



procedure TForm1.Button1Click(Sender: TObject);
var
  crTblDsc : CRTblDesc;
  PHdb :  hDBIDb;
  RR : DBIResult;
  s : String;

const
  szTblName = 'pdoxtbl';
  szTblType = szParadox;
  szProbl   = '~~~Probl';

begin
  phDB:=Table1.DBHandle;
  FillChar(crTblDsc, SizeOf(CRTblDesc), #0);
  StrCopy(crTblDsc.szTblName, szTblName);
  StrCopy(crTblDsc.szTblType, szTblType);
      { Set the Password information }
  crTblDsc.bProtected    := Bool(TRUE);
  s:=Edit1.Text+#0;
  StrCopy(crTblDsc.szPassword, @s[1]);

  Table1.Active:=False;
  RR:=DbiDoRestructure(phDb, 1, @crTblDsc, nil, nil, pCHAR(szProbl), False);
  if RR<>0 then MessageDlg(' Restructure error #'+IntToStr(RR), mtError, [mbOK], 0);
  Table1.Active:=True;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 if OpenDialog1.Execute then
  begin
   Table1.Active:=False;
   Button1.Enabled:=False;
   Edit1.Enabled:=False;
   Table1.TableName:=OpenDialog1.FileName;

   try
    Table1.Active:=True;
    Button1.Enabled:=True;
    Edit1.Enabled:=True;
   finally
   end;

  end;
end;

end.
